xfs
[Top] [All Lists]

[PATCH RESEND 9/10] xfstest: shared/005: Test multiple fallocate collaps

To: viro@xxxxxxxxxxxxxxxxxx, david@xxxxxxxxxxxxx, bpm@xxxxxxx, tytso@xxxxxxx, adilger.kernel@xxxxxxxxx, jack@xxxxxxx, mtk.manpages@xxxxxxxxx
Subject: [PATCH RESEND 9/10] xfstest: shared/005: Test multiple fallocate collapse
From: Namjae Jeon <linkinjeon@xxxxxxxxx>
Date: Sun, 2 Feb 2014 14:47:20 +0900
Cc: linux-fsdevel@xxxxxxxxxxxxxxx, xfs@xxxxxxxxxxx, linux-ext4@xxxxxxxxxxxxxxx, linux-kernel@xxxxxxxxxxxxxxx, Namjae Jeon <linkinjeon@xxxxxxxxx>, Namjae Jeon <namjae.jeon@xxxxxxxxxxx>, Ashish Sangwan <a.sangwan@xxxxxxxxxxx>
Delivered-to: xfs@xxxxxxxxxxx
Dkim-signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113; h=from:to:cc:subject:date:message-id; bh=VD4UBB+s3bw+JsB456jsdCH7ASBZkia5f5XtmFcCMfY=; b=IxB2lvL8TsGRiNa4WH+C3I0gr5bdwGA5OEAzpBv9nlers3B/tmZQwXAFHqVzWSimG6 hlwg004HodpJBjfIRJQNKRZifiLVk15k5SN9E5U25gBo+W+EinlCG4Rd/waAak2Ki0GQ P/zYakbzSsmQQM6ogUaB0Rc1bIipKNBkDQIJ4JXJnLGjv//AFC7etKdGcaPFW9c0mxkO 2QpmZo6eS5Ln4l5HQehoW/xWv+roLiSsnbDh1RhOpjoX5JNBu02mAhy14pUgi08y2Ojs rAwjnk6ya5AH9ws6fesuR5OZ4poHkAGZXikTPTfvnV9b69tla/NPIEvgMsQ+KENMXsI2 8K/w==
From: Namjae Jeon <namjae.jeon@xxxxxxxxxxx>

We execute collapse range multiple times on same file.
Each collapse range call collapses a single alternate block.
After the test execution, file will be left with 80 blocks and
as much number of extents.
We also check for file system consistency after the completion.

Signed-off-by: Namjae Jeon <namjae.jeon@xxxxxxxxxxx>
Signed-off-by: Ashish Sangwan <a.sangwan@xxxxxxxxxxx>
---
 tests/shared/005     |   90 ++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/shared/005.out |    4 +++
 tests/shared/group   |    1 +
 3 files changed, 95 insertions(+)
 create mode 100644 tests/shared/005
 create mode 100644 tests/shared/005.out

diff --git a/tests/shared/005 b/tests/shared/005
new file mode 100644
index 0000000..1347e7f
--- /dev/null
+++ b/tests/shared/005
@@ -0,0 +1,90 @@
+#! /bin/bash
+# FS QA Test No. 5
+#
+# Test multiple fallocate collapse range calls on same file.
+# For different blocksizes, collapse a single alternate block multiple times
+# until the file is left with 80 blocks and as much number of extents.
+# Also check for file system consistency after completing this operation
+# for each blocksize.
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Samsung Electronics.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1       # failure is the default!
+trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs xfs ext4
+_supported_os Linux
+
+_require_scratch
+_require_xfs_io_fiemap
+_require_xfs_io_falloc_collapse
+_do_die_on_error=y
+testfile=$SCRATCH_MNT/$seq.$$
+BLOCKS=10240
+
+for (( BSIZE = 1024; BSIZE <= 4096; BSIZE *= 2 )); do
+
+       length=$(($BLOCKS * $BSIZE))
+       case $FSTYP in
+       xfs)
+       _scratch_mkfs -b size=$BSIZE >> $seqres.full 2>&1
+       ;;
+       ext4)
+       _scratch_mkfs -b $BSIZE >> $seqres.full 2>&1
+       ;;
+       esac
+       _scratch_mount >> $seqres.full 2>&1
+
+       # Write file
+       $XFS_IO_PROG -f -c "pwrite 0 $length" -c fsync $testfile > /dev/null
+
+       # Collapse alternate blocks 
+       for (( i = 1; i <= 7; i++ )); do
+               for (( j=0; j < $(($BLOCKS/(2**$i))); j++ )); do
+                       offset=$(($j*$BSIZE))
+                       $XFS_IO_PROG -c "fcollapse $offset $BSIZE" $testfile > 
/dev/null
+               done
+       done
+
+       # Check if 80 extents are present
+       $XFS_IO_PROG -c "fiemap -v" $testfile | grep "^ *[0-9]*:" |wc -l
+
+       _check_scratch_fs
+       if [ $? -ne 0 ]; then
+               status=1
+               exit
+       fi
+
+       umount $SCRATCH_MNT
+done
+
+# success, all done
+status=0
+exit
diff --git a/tests/shared/005.out b/tests/shared/005.out
new file mode 100644
index 0000000..8d30b9d
--- /dev/null
+++ b/tests/shared/005.out
@@ -0,0 +1,4 @@
+QA output created by 005
+80
+80
+80
diff --git a/tests/shared/group b/tests/shared/group
index fb1d6d0..22f1d3a 100644
--- a/tests/shared/group
+++ b/tests/shared/group
@@ -7,6 +7,7 @@
 002 auto prealloc
 003 auto prealloc
 004 auto prealloc
+005 auto prealloc
 032 mkfs auto quick
 051 acl udf auto quick
 218 auto fsr quick
-- 
1.7.9.5

<Prev in Thread] Current Thread [Next in Thread>
  • [PATCH RESEND 9/10] xfstest: shared/005: Test multiple fallocate collapse, Namjae Jeon <=